package com.dar.nclientv2.components.activities;

import android.content.res.Configuration;

import androidx.appcompat.app.AppCompatActivity;
import androidx.recyclerview.widget.GridLayoutManager;
import androidx.recyclerview.widget.RecyclerView;
import androidx.swiperefreshlayout.widget.SwipeRefreshLayout;

public abstract class BaseActivity extends AppCompatActivity {
    protected RecyclerView recycler;
    protected SwipeRefreshLayout refresher;
    public SwipeRefreshLayout getRefresher() {
        return refresher;
    }
    public RecyclerView getRecycler() {
        return recycler;
    }
    @Override
    public void onConfigurationChanged(Configuration newConfig) {
        super.onConfigurationChanged(newConfig);
        if (newConfig.orientation == Configuration.ORIENTATION_LANDSCAPE) {
            changeLayout(true);
        } else if (newConfig.orientation == Configuration.ORIENTATION_PORTRAIT){
            changeLayout(false);
        }
    }
    protected abstract int getPortCount();
    protected abstract int getLandCount();
    protected void changeLayout(boolean landscape){
        final int count=landscape? getLandCount():getPortCount();
        int first=recycler.getLayoutManager()==null?0:((GridLayoutManager)recycler.getLayoutManager()).findFirstCompletelyVisibleItemPosition();
        RecyclerView.Adapter adapter=recycler.getAdapter();
        GridLayoutManager gridLayoutManager=new GridLayoutManager(this,count);
        recycler.setLayoutManager(gridLayoutManager);
        recycler.setAdapter(adapter);
        recycler.scrollToPosition(first);
    }

}
